<h1 align="center">Selamat datang di OpenSID! 👋</h1>

![readme-image](https://user-images.githubusercontent.com/46939846/103254436-d5381f80-49b7-11eb-8c2b-99dc4c7de30b.png "OpenSID membantu penanggulangan COVID-19")

### 🤔 Apa itu OpenSID?
OpenSID (https://github.com/OpenSID/OpenSID) adalah Sistem Informasi Desa (SID) yang sengaja dibuat supaya terbuka dan dapat dikembangkan bersama-sama oleh komunitas peduli SID.

**SID diharapkan dapat membantu pemerintah desa dalam beberapa hal berikut:**

- Kantor Desa lebih efisien dan efektif
- Pemerintah Desa lebih transparan dan akuntabel
- Layanan Publik lebih baik
- Warga mendapat akses lebih baik pada informasi desa

> OpenSID bertujuan agar ke semua 74ribu+ desa di Indonesia dapat menerapkan sistem informasi untuk memajukan desanya.

**Strategi pengembangan OpenSID adalah untuk:**
- Memudahkan pengguna untuk mendapatkan SID secara bebas, tanpa proses birokrasi
- Memudahkan pengguna menyerap rilis SID baru
- Memungkinkan pegiat SID untuk membuat kontribusi langsung pada _source code_ aplikasi SID

**OpenSID dikelola di Github untuk:**
- Merekam semua perubahan yg dibuat
- Memungkinkan kembali ke revisi sebelumnya, apabila diperlukan
- Memudahkan kolaborasi antar pegiat SID dan juga dengan desa dampingan dalam mengembangkan SID
- Backup online _source code_ SID yg dapat diakses setiap saat

## 📃 PEDOMAN PENGGUNAAN
Pedoman pemasangan dan penggunaan OpenSID dapat dilihat di wiki OpenSID di https://github.com/opensid/opensid/wiki.

## 📑 HAK CIPTA, SYARAT, DAN KETENTUAN
Aplikasi Sistem Informasi Desa (SID) dibangun dan dikembangkan pada awalnya oleh COMBINE Resource Institution sejak tahun 2009. Pemegang hak cipta aslinya adalah Combine Resource Institution (http://lumbungkomunitas.net/).

Sistem ini dikelola dengan merujuk pada lisensi **GNU General Public License Version 3** (http://www.gnu.org/licenses/gpl.html).

**Versi di Github ini dikembangkan sejak Mei 2016, gratis dan bebas untuk dimanfaatkan dan dikembangkan oleh semua desa. Hak Cipta OpenSID sekarang dipegang oleh Perkumpulan Desa Digital Terbuka (https://opendesa.id), lembaga hukum yang sengaja dibentuk untuk mengelola OpenSID.**

## 💻 DEMO
Demo aplikasi OpenSID dapat dilihat di https://demo.opensid.or.id. Versi yang terlihat di demo itu adalah rilis Umum terkini. Modul administrasi demo OpenSID dapat diaskses pada https://demo.opensid.or.id/index.php/siteman. Masukkan Username = admin dan Password = sid304.

Versi Premium dapat diujicoba di https://berputar.opensid.or.id. Versi ini disediakan bagi pelanggan fitur Premium. Modul administrasi demo versi Premium dapat diaskses pada https://berputar.opensid.or.id/index.php/siteman. Masukkan Username = admin dan Password = sid304.

### 💬 FORUM

Anda dapat bergabung dengan [Forum Pengguna dan Pegiat OpenSID](https://www.facebook.com/groups/opensid) di Facebook atau di [Telegram](http://bit.ly/2DG6Beb). Kedua group ini bersifat informal dan merupakan tempat berbagi informasi dan saling membantu menggunakan dan mengembangkan aplikasi OpenSID.

## 🤝 KEMBANGKAN BERSAMA

Pengguna dan pegiat SID dapat melaporkan dan mendaftarkan masalah/usulan/permintaan perbaikan atau pengembangan OpenSID di https://github.com/opensid/opensid/issues. Laporan ini merupakan daftar tugas bagi pegiat OpenSID untuk mengembangkan OpenSID berdasarkan masukan dari komunitas SID.

Komunitas SID juga bebas, bahkan diajak, untuk turut membuat kontribusi pada panduan OpenSID di https://github.com/OpenSID/OpenSID/wiki, dan pada script OpenSID di (https://github.com/OpenSID/OpenSID).

## 💰 DONASI

[![Backers on Open Collective](https://opencollective.com/OpenSID/backers/badge.svg)](#backers)
[![Sponsors on Open Collective](https://opencollective.com/OpenSID/sponsors/badge.svg)](#sponsors)

### 🧑 Pendukung

Peduli dengan OpenSID dan misinya membangun desa? [Jadilah pendukung OpenSID](https://opencollective.com/OpenSID#backer).
<a href="https://opencollective.com/OpenSID#backers" target="_blank"><img src="https://opencollective.com/OpenSID/backers.svg?width=890"></a>

> Atau bisa donasi langsung ke rekening bank. Lihat informasi lengkap [di sini](https://opendesa.id/donasi).

### ⭐️ Sponsor

Apakah desa/lembaga/perusahaan anda mendapat manfaat dari OpenSID? Bantu kami terus kembangkan OpenSID dengan [menjadi sponsor](https://opencollective.com/OpenSID#sponsor). Logo sponsor akan tampil di sini bersama tautan ke website anda.
<a href="https://opencollective.com/OpenSID#backers" target="_blank"><img src="https://opencollective.com/OpenSID/sponsors.svg?width=890"></a>

##  👨‍💻KONTRIBUTOR
Berikut adalah teman-teman luar biasa yang telah berkontribusi langsung mengembangkan aplikasi OpenSID. ([emoji key](https://github.com/kentcdodds/all-contributors#emoji-key))

<!-- ALL-CONTRIBUTORS-LIST:START - Do not remove or modify this section -->
| [<img src="https://avatars2.githubusercontent.com/u/16488673?s=400&v=4" width="100px;"/><br /><sub><b>Abdul Gani</b></sub>](https://github.com/batudaa)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=batudaa "Code") [🔧](https://github.com/batudaa/batudaa-theme) | [<img src="https://avatars0.githubusercontent.com/u/19917739?s=460&v=4" width="100px;"/><br /><sub><b>Happy Agung</b></sub>](https://github.com/metalab25)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=metalab25 "Code") | [<img src="https://avatars2.githubusercontent.com/u/10582583?s=460&v=4" width="100px;"/><br /><sub><b>Suyadi</b></sub>](https://github.com/esyede)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=esyede "Code") | [<img src="https://avatars3.githubusercontent.com/u/1905469?s=460&v=4" width="100px;"/><br /><sub><b>cafeiklan</b></sub>](https://github.com/cafeiklan)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=cafeiklan "Code") | [<img src="https://scontent.fmel5-1.fna.fbcdn.net/v/t1.0-1/c1.0.295.295/13006503_10206151340131094_1877719533061445211_n.jpg?_nc_cat=0&oh=47afde62179860ed0c59c94974875eac&oe=5BF79D49" width="100px;"/><br /><sub><b>Bimo Aji Pamungkas</b></sub>](https://www.facebook.com/i177o)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=ombimo "Code") | [<img src="https://avatars2.githubusercontent.com/u/1229849?s=460&v=4" width="100px;"/><br /><sub><b>Ayi Sumarna</b></sub>](https://github.com/siayi)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=siayi "Code") [🐛](https://github.com/OpenSID/OpenSID/issues?q=author%3Asiayi) | [<img src="https://avatars3.githubusercontent.com/u/1853475?s=460&v=4" width="100px;"/><br /><sub><b>Ahmad Afandi</b></sub>](https://github.com/pandigresik)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=pandigresik "Code") |
| :---: | :---: | :---: | :---: | :---: | :---: | :---: |
| [<img src="https://avatars0.githubusercontent.com/u/26613576?s=460&v=4" width="100px;"/><br /><sub><b>simasta</b></sub>](https://github.com/simasta)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=simasta "Code") [🔧](https://github.com/simasta/wpsid-shortcode) | [<img src="https://avatars2.githubusercontent.com/u/26631297?s=460&v=4" width="100px;"/><br /><sub><b>Fathur Rahman</b></sub>](https://fathurvbf.wordpress.com/)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=fathurvbf "Code") | [<img src="https://avatars0.githubusercontent.com/u/28281443?s=460&v=4" width="100px;"/><br /><sub><b>sidesa</b></sub>](https://github.com/sidesa)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=sidesa "Code") | [<img src="https://avatars3.githubusercontent.com/u/8047705?s=460&v=4" width="100px;"/><br /><sub><b>Yogi Erka Julyansa Putra</b></sub>](https://github.com/Erkajp)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=Erkajp "Code") | [<img src="https://avatars1.githubusercontent.com/u/15242209?s=460&v=4" width="100px;"/><br /><sub><b>arzaddin</b></sub>](https://github.com/arzaddin)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=arzaddin "Code") | [<img src="https://scontent.fmel5-1.fna.fbcdn.net/v/t1.0-1/c53.0.320.320/p320x320/12032216_129508434070379_4536914696271402899_n.jpg?_nc_cat=0&oh=136d5e35e18f4f6a8f8c35e53f8932bb&oe=5C12AD62" width="100px;"/><br /><sub><b>Adi Rahman</b></sub>](https://www.facebook.com/profile.php?id=100010336693162)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=kodingku "Code") | [<img src="https://avatars1.githubusercontent.com/u/25834335?s=460&v=4" width="100px;"/><br /><sub><b>Muhammad</b></sub>](https://github.com/MUHAMMADRANGSEL)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=MUHAMMADRANGSEL "Code") [🐛](https://github.com/OpenSID/OpenSID/issues?q=author%3AMUHAMMADRANGSEL) |
| [<img src="https://avatars2.githubusercontent.com/u/35319600?s=460&v=4" width="100px;"/><br /><sub><b>balongbesuk</b></sub>](https://github.com/balongbesuk)<br />[🐛](https://github.com/OpenSID/OpenSID/issues?q=author%3Abalongbesuk) | [<img src="https://avatars1.githubusercontent.com/u/6611881?s=460&v=4" width="100px;"/><br /><sub><b>Syafri</b></sub>](https://github.com/afri18)<br />[🐛](https://github.com/OpenSID/OpenSID/issues?q=author%3Aafri18) | [<img src="https://avatars1.githubusercontent.com/u/9961837?s=460&v=4" width="100px;"/><br /><sub><b>Diego Dafma</b></sub>](https://www.facebook.com/Egodasa)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=egodasa "Code") | [<img src="https://avatars3.githubusercontent.com/u/32443765?s=460&v=4" width="100px;"/><br /><sub><b>Mugi Fadilah</b></sub>](https://facebook.com/modol.net)<br />[🐛](https://github.com/OpenSID/OpenSID/issues?q=author%3Amugi789) | [<img src="https://avatars0.githubusercontent.com/u/28652833?s=460&v=4" width="100px;"/><br /><sub><b>Sugianto Rusli</b></sub>](https://www.facebook.com/sugianto.rusli)<br />[🐛](https://github.com/OpenSID/OpenSID/issues?q=author%3Asugiantoe) | [<img src="https://avatars0.githubusercontent.com/u/13196484?s=460&v=4" width="100px;"/><br /><sub><b>Gun Gun Priatna</b></sub>](https://github.com/doublegunz)<br />[🐛](https://github.com/OpenSID/OpenSID/issues?q=author%3Adoublegunz) | [<img src="https://scontent.fmel5-1.fna.fbcdn.net/v/t1.0-1/p320x320/36992497_1740985615984741_947870076449587200_n.jpg?_nc_cat=0&oh=6949401b9e4b80f402766ddac78771e3&oe=5C0F932A" width="100px;"/><br /><sub><b>Agung Suryo Putra</b></sub>](https://www.facebook.com/agung.askcom1)<br />[📖](http://bit.ly/panduan-opensid-pdf) |
|[<img src="https://scontent.fmel5-1.fna.fbcdn.net/v/t1.0-1/p320x320/35694823_10212348165923653_4772027936544915456_n.jpg?_nc_cat=0&oh=ad8097e43f560a75700ae0f7eba70eb2&oe=5C0B0DEC" width="100px;"/><br /><sub><b>Rizki Noor Hidayat Wijaya</b></sub>](https://www.facebook.com/riskydigital)<br />[🔧](https://drive.google.com/drive/folders/1tX3gBw7zRUjo2QliCKWMHcTFVjd2f5h7) |[<img src="https://avatars1.githubusercontent.com/u/3823496?s=460&v=4" width="100px;"/><br /><sub><b>Yusup Hambali</b></sub>](https://github.com/suphm)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=suphm "Code")|[<img src="https://scontent.fmel5-1.fna.fbcdn.net/v/t1.0-1/385303_627976277231445_1453339498_n.jpg?_nc_cat=0&oh=5ace166fb88116e637bf3cc8f2dafa96&oe=5BF377AB" width="100px;"/><br /><sub><b>Wong Cilik Poenya</b></sub>](https://www.facebook.com/wongcilik.poenya)<br />[🐛](https://github.com/OpenSID/OpenSID/issues?q=author%3Awongcilikpoenya) |[<img src="https://avatars3.githubusercontent.com/u/22895596?s=460&v=4" width="100px;"/><br /><sub><b>redjoel</b></sub>](https://github.com/redjoel)<br />[🐛](https://github.com/OpenSID/OpenSID/issues?q=author%3Aredjoel)|[<img src="https://avatars1.githubusercontent.com/u/3823496?s=460&v=4" width="100px;"/><br /><sub><b>djowah</b></sub>](https://github.com/djowah)<br />[🐛](https://github.com/OpenSID/OpenSID/issues?q=author%3Adjowah)|[<img src="https://avatars2.githubusercontent.com/u/11713976?s=400&v=4" width="100px;"/><br /><sub><b>Didik Kurniawan</b></sub>](https://github.com/didikkurniawan)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=didikkurniawan "Code")|[<img src="https://scontent.fmel5-1.fna.fbcdn.net/v/t1.0-1/p320x320/24899783_380907915690689_5256535469427363350_n.jpg?_nc_cat=0&oh=80cb718e7a49ee10769348670826773a&oe=5BE6BC03" width="100px;"/><br /><sub><b>Muh Sukri Malendra</b></sub>](https://www.facebook.com/muhsukrimalendra)<br />[🐛](https://github.com/OpenSID/OpenSID/issues?q=author%3Asukrimalendra)|
|[<img src="https://avatars0.githubusercontent.com/u/13029584?s=460&v=4" width="100px;"/><br /><sub><b>Faisal Yudo Hernawan</b></sub>](https://github.com/jrsfaisal)<br />[🐛](https://github.com/OpenSID/OpenSID/issues?q=author%3Ajrsfaisal)|[<img src="https://avatars0.githubusercontent.com/u/40737002?s=460&v=4" width="100px;"/><br /><sub><b>Gusti SF</b></sub>](https://github.com/gustisf)<br />[🐛](https://github.com/OpenSID/OpenSID/issues?q=author%3Agustisf)|[<img src="https://scontent.fmel5-1.fna.fbcdn.net/v/t1.0-1/p320x320/14102491_1363655336995273_8116645141937620200_n.jpg?_nc_cat=0&oh=1c8560ca4059c6d0c009de356a68716c&oe=5BDE9F25" width="100px;"/><br /><sub><b>Muhamad Difa</b></sub>](https://www.facebook.com/difa.alexsandria.9)<br />[🐛](https://github.com/OpenSID/OpenSID/issues?q=author%3Amuhamaddifa)|[<img src="https://scontent.fmel5-1.fna.fbcdn.net/v/t1.0-1/c0.53.320.320/p320x320/32782654_2016789691917650_2677678857972088832_n.jpg?_nc_cat=0&oh=10b37209c47c50d0d677f040d64d0591&oe=5BA32936" width="100px;"/><br /><sub><b>Mizwaruddin</b></sub>](https://www.facebook.com/mizwaruddin.mizwaruddin)<br />[🐛](https://github.com/OpenSID/OpenSID/issues?q=author%3Amizwaruddin)|[<img src="https://avatars0.githubusercontent.com/u/26156030?s=460&v=4" width="100px;"/><br /><sub><b>CIJERUK</b></sub>](https://github.com/CIJERUK)<br />[🐛](https://github.com/OpenSID/OpenSID/issues?q=author%3ACIJERUK)|[<img src="https://avatars2.githubusercontent.com/u/38773660?s=460&v=4" width="100px;"/><br /><sub><b>makhbub</b></sub>](https://github.com/makhbub)<br />[🐛](https://github.com/OpenSID/OpenSID/issues?q=author%3Amakhbub)|[<img src="https://scontent.fmel5-1.fna.fbcdn.net/v/t1.0-1/p320x320/35114714_2091475807529495_3380715509124169728_n.jpg?_nc_cat=0&oh=d6825664a005b5fe13bbe8435b85d13b&oe=5BE8AD83" width="100px;"/><br /><sub><b>Wira Ade Putra</b></sub>](https://www.facebook.com/xnuser)<br />[📖](https://bit.ly/brosur-opensid)|
|[<img src="https://avatars2.githubusercontent.com/u/10989147?s=460&v=4" width="100px;"/><br /><sub><b>Agung Sugiarto</b></sub>](https://github.com/agungsugiarto)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=agungsugiarto "Code")|[<img src="https://avatars1.githubusercontent.com/u/10823012?s=460&v=4" width="100px;"/><br /><sub><b>andialrizki</b></sub>](https://github.com/andialrizki)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=andialrizki "Code")|[<img src="https://avatars1.githubusercontent.com/u/27580502?s=400&v=4" width="100px;"/><br /><sub><b>Morhan Tambunan</b></sub>](https://github.com/mananya)<br />[🐛](https://github.com/OpenSID/OpenSID/issues?q=author%3Amananya)|[<img src="https://avatars1.githubusercontent.com/u/13099373?s=460&v=4" width="100px;"/><br /><sub><b>Muhammad Irwan Andriawan</b></sub>](https://github.com/andriawan)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=andriawan "Code")|[<img src="https://scontent.fsuv1-1.fna.fbcdn.net/v/t1.0-1/c127.0.320.320/p320x320/11008415_1027748060588702_6863130820414376194_n.jpg?_nc_cat=0&oh=c4f562cbed42b400e0db060e5f8105d2&oe=5C2CBD36" width="100px;"/><br /><sub><b>Andry Rukandi Fauzy</b></sub>](https://web.facebook.com/andryrukandifauzy)<br />[🐛](https://github.com/OpenSID/OpenSID/issues?q=author%3Aandryrukandifauzy)|[<img src="https://avatars2.githubusercontent.com/u/34742217?s=460&v=4" width="100px;"/><br /><sub><b>WAHAB01</b></sub>](https://github.com/WAHAB01)<br />[🐛](https://github.com/OpenSID/OpenSID/issues?q=author%3AWAHAB01)|[<img src="https://avatars2.githubusercontent.com/u/4893216?s=400&v=4" width="100px;"/><br /><sub><b>Rizal Alfiannor</b></sub>](https://github.com/rizalblue)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=rizalblue "Code")|
|[<img src="https://scontent.fmel5-1.fna.fbcdn.net/v/t1.0-1/p320x320/10685529_10205083651518322_2863585881663459125_n.jpg?_nc_cat=100&_nc_ht=scontent.fmel5-1.fna&oh=6c02ad38eafd352ed17f1105ba48f939&oe=5CA6C74B" width="100px;"/><br /><sub><b>Lukman Hakim</b></sub>](https://www.facebook.com/lukman.uki)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=lukman48 "Code")|[<img src="https://avatars0.githubusercontent.com/u/45263721?s=460&v=4" width="100px;"/><br /><sub><b>Hari Saputra</b></sub>](https://github.com/hasap86)<br />[🐛](https://github.com/OpenSID/OpenSID/issues?q=author%3Ahasap86)|[<img src="https://avatars0.githubusercontent.com/u/22239074?s=460&v=4B" width="100px;"/><br /><sub><b>Diki Siswanto</b></sub>](https://github.com/dikisiswanto)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=xanarciz "Code")|[<img src="https://avatars0.githubusercontent.com/u/46323158?s=400&v=4" width="100px;"/><br /><sub><b>Andi Pratama Suparminto</b></sub>](https://github.com/xanarciz)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=xanarciz "Code")|[<img src="https://avatars3.githubusercontent.com/u/36057801?s=460&v=4" width="100px;"/><br /><sub><b>Snoopy-Sec</b></sub>](https://github.com/snoopy-sec)<br />[🐛](https://github.com/OpenSID/OpenSID/issues?q=author%3Asnoopy-sec)|[<img src="https://avatars0.githubusercontent.com/u/45786885?s=460&v=4" width="100px;"/><br /><sub><b>Rudi Purwanto</b></sub>](https://github.com/roaddee)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=roaddee "Code")|[<img src="https://avatars3.githubusercontent.com/u/33612251?s=460&v=4" width="100px;"/><br /><sub><b>I Kadek Galiarta</b></sub>](https://github.com/Galiarta)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=Galiarta "Code")|
|[<img src="https://scontent.fmel5-1.fna.fbcdn.net/v/t31.0-1/c56.56.694.694a/s320x320/242423_1862790842044_7981017_o.jpg?_nc_cat=105&_nc_ht=scontent.fmel5-1.fna&oh=50e33c01e2d62f43660d7285d3741f97&oe=5D72760D" width="100px;"/><br /><sub><b>Muhammad Ihsan</b></sub>](https://www.facebook.com/muhammad.ihsan.522)<br />[💻](# "Code")|[<img src="https://avatars3.githubusercontent.com/u/46939846?s=460&v=4" width="100px;"/><br /><sub><b>Ariandi Ryan Kahfi</b></sub>](https://github.com/ariandii)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=ariandii "Code")|[<img src="https://avatars1.githubusercontent.com/u/832277?s=460&v=4" width="100px;"/><br /><sub><b>Oddy Virgantara Putra</b></sub>](https://github.com/virgantara)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=virgantara "Code")|[<img src="https://avatars0.githubusercontent.com/u/6558409?s=460&v=4" width="100px;"/><br /><sub><b>Wildan Agissa Rusadi</b></sub>](https://github.com/dankrez48)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=dankrez48 "Code")|[<img src="https://avatars0.githubusercontent.com/u/51182125?s=460&v=4" width="100px;"/><br /><sub><b>Uncu</b></sub>](https://github.com/uncu29)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=uncu29 "Code")|[<img src="https://avatars3.githubusercontent.com/u/10545975?s=460&v=4" width="100px;"/><br /><sub><b>Rismawan Junandia</b></sub>](https://github.com/junandia)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=junandia "Code")|[<img src="https://avatars3.githubusercontent.com/u/22895596?s=460&v=4" width="100px;"/><br /><sub><b>Julis Suryadi</b></sub>](https://github.com/redjoel)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=redjoel "Code")|
|[<img src="https://avatars0.githubusercontent.com/u/16215220?s=460&v=4" width="100px;"/><br /><sub><b>Kusmanto Pratama</b></sub>](https://github.com/kusmantopratama)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=kusmantopratama "Code")|[<img src="https://avatars2.githubusercontent.com/u/22736771?s=460&v=4" width="100px;"/><br /><sub><b>Alvin Leonardo</b></sub>](https://github.com/0to1a)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=0to1a "Code")|[<img src="https://avatars3.githubusercontent.com/u/33674500?s=460&v=4" width="100px;"/><br /><sub><b>Alvin Leonardo</b></sub>](https://github.com/ropelid)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=ropelid "Code")|[<img src="https://avatars0.githubusercontent.com/u/22783252?s=460&v=4" width="100px;"/><br /><sub><b>Nursan Amar</b></sub>](https://github.com/nursanamar)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=nursanamar "Code")|[<img src="https://avatars0.githubusercontent.com/u/10391199?s=460&v=4" width="100px;"/><br /><sub><b>Zeppy Shiddiq</b></sub>](https://github.com/fusionid)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=fusionid "Code")|[<img src="https://avatars0.githubusercontent.com/u/4956745?s=400&v=4" width="100px;"/><br /><sub><b>Riyandika Andhi</b></sub>](https://github.com/riyandika)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=riyandika "Code")|[<img src="https://avatars0.githubusercontent.com/u/7290110?s=400&v=4" width="100px;"/><br /><sub><b>zeroturn</b></sub>](https://github.com/ZER07URN)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=ZER07URN "Code")|
|[<img src="https://avatars2.githubusercontent.com/u/60131374?s=400&v=4" width="100px;"/><br /><sub><b>ianskids</b></sub>](https://github.com/ianskids)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=ianskids "Code")|[<img src="https://avatars3.githubusercontent.com/u/57283157?s=400&v=4" width="100px;"/><br /><sub><b>afa28</b></sub>](https://github.com/afa28)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=afa28 "Code")|[<img src="https://avatars3.githubusercontent.com/u/13193883?s=400&v=4" width="100px;"/><br /><sub><b>af-lazuardi</b></sub>](https://github.com/af-lazuardi)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=af-lazuardi "Code")|[<img src="https://avatars0.githubusercontent.com/u/19631687?s=460&v=4" width="100px;"/><br /><sub><b>masumo</b></sub>](https://github.com/masumo)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=masumo "Code")|[<img src="https://avatars3.githubusercontent.com/u/20630687?s=460&u=f0f5e17990dd5ef7c3893dc519813308ab389194&v=4" width="100px;"/><br /><sub><b>Erick Surya Dinata</b></sub>](https://github.com/ericksuryadinata)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=ericksuryadinata "Code")|[<img src="https://avatars3.githubusercontent.com/u/47693495?s=460&u=313533001b27f6278af5f501725d77bcbc06ab8f&v=4" width="100px;"/><br /><sub><b>DwiyanTech</b></sub>](https://github.com/DwiyanTech)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=DwiyanTech "Code")|[<img src="https://avatars3.githubusercontent.com/u/31075119?s=460&u=08fa78160dff5db1ce758a4e859da0aedd188338&v=4" width="100px;"/><br /><sub><b>Faizul Amali</b></sub>](https://github.com/ilamazuliaf)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=ilamazuliaf "Code")|
|[<img src="https://avatars0.githubusercontent.com/u/56395293?s=460&u=345ee7aa218708a188a4faec71fb8eae5e3660da&v=4" width="100px;"/><br /><sub><b>Tsamara Ali</b></sub>](https://github.com/AliAshgar)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=AliAshgar "Code")|[<img src="https://avatars3.githubusercontent.com/u/58940381?s=460&v=4" width="100px;"/><br /><sub><b>yonathanrizky</b></sub>](https://github.com/yonathanrizky)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=yonathanrizky "Code")|[<img src="https://avatars2.githubusercontent.com/u/58840312?s=460&v=4" width="100px;"/><br /><sub><b>Fadhil Prawira</b></sub>](https://github.com/FadhilPrawira)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=FadhilPrawira "Code")|[<img src="https://avatars2.githubusercontent.com/u/22933759?s=400&u=59a75e2d97c8d22fb89417687839330fa7731d82&v=4" width="100px;"/><br /><sub><b>Nopezi Saputra</b></sub>](https://github.com/nopezi)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=nopezi "Code")|[<img src="https://avatars2.githubusercontent.com/u/10989147?s=460&u=4017130da642a5ff1a54505a8202a52cc5b1c77b&v=4" width="100px;"/><br /><sub><b>Agung Sugiarto</b></sub>](https://github.com/agungsugiarto)<br />[💻](https://github.com/OpenSID/OpenSID/commits?author=agungsugiarto "Code")|||
